-- $Id: LoginPasswordAuthenticator.lua 100483 2010-01-07 18:14:59Z brunoos $

local Authenticator = require "openbus.authenticators.Authenticator"

local oop = require "loop.simple"

---
--Utilizado para efetuar a autenticao de uma entidade junto ao Servio de
--Controle de Acesso atravs de um login e uma senha.
---
module("openbus.authenticators.LoginPasswordAuthenticator")

oop.class(_M, Authenticator)

function __init(self, name, password)
  return oop.rawnew(self, {
	  name = name,
	  password = password,
  })
end

---
--@see openbus.authenticators.Authenticator#authenticate
---
function authenticate(self, acs)
  local succ, credential, lease = acs:loginByPassword(self.name, self.password)
  if succ then
    return credential, lease
  end
  return nil, -1
end
