-- $Id: PICurrent.lua 106365 2010-06-01 20:11:34Z augusto $

local oil = require "oil"
local oop = require "loop.base"

local setmetatable = setmetatable

---
--Objeto que permite a transferncia de informaes de um interceptador
--para o tratador de uma requisio de servio.
---
module("openbus.interceptors.PICurrent", oop.class)

---
--Constri o objeto.
--
--@return O objeto.
---
function __init(self)

  -- Os valores transferidos sero armazenados em uma tabela de chaves fracas.
  -- As chaves dessa tabela so as corotinas associadas s requisies.
  -- Assumimos que o oil cria uma nova corotina para cada requisio

  local picurrentTable = {}
  setmetatable(picurrentTable, {__mode = "k"})
  return oop.rawnew(self, {picurrentTable = picurrentTable})
end

---
--Insere um valor na tabela de transferncia
--
--@param value O valor.
---
function setValue(self, value)
  self.picurrentTable[oil.tasks.current] = value
end

---
--Obtm um valor da tabela de transferncia
--
--@return O valor.
---
function getValue(self)
  return self.picurrentTable[oil.tasks.current]
end
