-- $Id: log.lua 99700 2009-12-04 20:51:35Z rodrigoh $

local Viewer = require "loop.debug.Viewer"
local Verbose = require "loop.debug.Verbose"

---
--Mecanismo para debug do SCS baseado no mdulo Verbose provido pelo LOOP
---
module ("scs.core.log", Verbose)

-- Coloca data e hora no log
timed = "%d/%m %H:%M:%S"

-- Usa uma instncia prpria do Viewer para no interferir com o do OiL
viewer = Viewer{
           maxdepth = 2,
           indentation = "|  ",
           -- output = io.output()
         }

-- Definio dos tags que compem cada grupo
groups.basic = {"init", "warn", "error"}
groups.service = {"execution_node", "container"}
groups.mechanism = {"interceptor", "conn"}
groups.core = {"scs"}
groups.all = {"basic", "service", "core"}

-- Definio dos nveis de debug (em ordem crescente)
_M:newlevel{"basic"}
_M:newlevel{"service"}
_M:newlevel{"core"}

-- Caso seja necessrio exibir o horrio do registro
-- timed.basic =  "%d/%m %H:%M:%S"
-- timed.all =  "%d/%m %H:%M:%S"
